#!/usr/local/bin/pgoblin -f
  Copyright (C)2019 @BABOLO http://www.babolo.ru/
--PKG = mini-cipa
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: minicipa.pgoblin.m4,v 1.19 2019/09/16 00:16:58 babolo Exp $

#connect 0001
sqlite2
#perform 0001
CREATE TEMP TABLE a(i int, a text);
#getarg  1
#copyin  0011
COPY a FROM stdin;
#close   101
#perform 0001
CREATE TEMP TABLE e(i int, n text, e text);
#getenv  1
#copyin  0011
COPY e FROM stdin;
#close   101
#perform 0001
CREATE TEMP TABLE x
     ( b text    --    (PROTOVER)  'minicipa'
     , u text    --    (${USER})
     , a text    --    (PROTOVER)
     )
;
#perform 0001
INSERT INTO x
 SELECT COALESCE( (SELECT a FROM a WHERE i = 0 AND regexp('^[a-z0-9_]+$', a))
                , 'minicipa'
                )
      , (SELECT e FROM e WHERE n = 'USER' AND regexp('^[a-z0-9_]+$', e))
      , (SELECT a FROM a WHERE i = 0 AND regexp('^[a-z0-9_]+$', a))
;
#perform 0001
CREATE TEMP TABLE v
     ( v numeric --   
     )
;
#select  1001
SELECT 'PREFIX/include/babolo/PKG' || COALESCE(':' || a, '') || '.VERSION'
 FROM x
;
#cat     V1
#trap
#echo
Ignore it

#perform 0001
INSERT INTO v VALUES(VERS)
#return
#copyin  00V1
COPY v;
#untrap
#connect 000T
pgsql dbname=template1 requirepeer=postgres application_name=minicipa
#select  G001
SELECT 'CREATE DATABASE ' || b || ';' FROM x;
#select  J001
SELECT 'CREATE ROLE ' || b || ' WITH LOGIN;' FROM x;
#select  1001
SELECT 'CREATE ROLE ' || u || ' WITH LOGIN;' FROM x;
#trap
#echo
@@@Ignore it

#return
#perform 000T
CREATE ROLE root WITH LOGIN;
#perform 000T
CREATE ROLE operator WITH NOLOGIN;
#perform 0G0T
#perform 0J0T
#perform 010T
#untrap
#select  1001
SELECT 'pgsql dbname=' || b || ' requirepeer=postgres application_name=minicipa'
 FROM x
;
#connect 0102
#close   101
#close   G0G
#close   J0J
#select  1001
SELECT 'GRANT ALL ON DATABASE ' || b || ' TO ' || b || ';' FROM x;
#perform 0102
#select  1001
SELECT 'GRANT CONNECT, TEMP ON DATABASE ' || b || ' TO root, operator;' FROM x;
#perform 0102
#perform 0002
CREATE EXTENSION IF NOT EXISTS babolo_pglib;
#perform 0002
ALTER EXTENSION babolo_pglib UPDATE;
#perform 0002  ###########################################################     ####
CREATE TABLE IF NOT EXISTS public.ciparam
     ( m      text
     , v      text
     , param  text
     , PRIMARY KEY(m, v)
     )
;
#perform 0002
COMMENT ON TABLE public.ciparam        IS '  ';
COMMENT ON COLUMN public.ciparam.m        IS ',   ̣ ';
COMMENT ON COLUMN public.ciparam.v        IS '   ';
COMMENT ON COLUMN public.ciparam.param    IS ' ';
#perform 0002
INSERT INTO public.ciparam
 SELECT 'PKG', 'timeout', '56min'
  WHERE NOT EXISTS(SELECT 1 FROM public.ciparam WHERE (m, v) = ('PKG', 'timeout'))
;
#perform 0002  #########################################################################    ####
CREATE SEQUENCE IF NOT EXISTS public.cipares_q MINVALUE 0;
#close   101
#perform 0002
CREATE TABLE IF NOT EXISTS public.cipares
     ( cipares    int4     PRIMARY KEY DEFAULT nextval('public.cipares_q')
     , ciparesnm  text     NOT NULL UNIQUE
     )
;
#perform 0002
ALTER TABLE public.cipares ADD UNIQUE(ciparesnm);
#perform 0002
COMMENT ON TABLE public.cipares          IS '  ';
COMMENT ON COLUMN public.cipares.cipares    IS ' ';
COMMENT ON COLUMN public.cipares.ciparesnm  IS ' ';
#perform 0002
CREATE SEQUENCE IF NOT EXISTS public.cipalevel_q MINVALUE 0;
#close   101
#trap                ----------------------------------------------------------------------------------
#select  1001        --  TABLE cipamask ,     ţ
SELECT '
INSERT INTO public.cipamask
 SELECT 0, public.bitex1('''', MAX(r))
  FROM(SELECT MAX(length(resource)) AS r FROM public.cipalan
      UNION
       SELECT MAX(cipares) FROM public.cipares
      )n
;
'
;
#return
#perform 0002
SELECT 1 FROM public.cipamask;
#untrap
#perform 0002
CREATE TABLE IF NOT EXISTS public.cipamask
     ( cipalevel int4      PRIMARY KEY DEFAULT nextval('public.cipalevel_q')
     , cipamask  varbit    NOT NULL
     )
;
#perform 0102        --  TABLE cipamask,  
#perform 0002        ----------------------------------------------------------------------------------
COMMENT ON TABLE public.cipamask         IS '';
COMMENT ON COLUMN public.cipamask.cipalevel IS '';
COMMENT ON COLUMN public.cipamask.cipamask  IS '';
#perform 0002
SELECT setval('public.cipalevel_q', MAX(cipamask.cipalevel)) FROM public.cipamask;
#perform 0002  ###########################################################################    ####
CREATE SEQUENCE IF NOT EXISTS public.cipalan_q MINVALUE 0;
#perform 0002
CREATE TABLE IF NOT EXISTS public.cipalan
     ( cipalan   int4      PRIMARY KEY DEFAULT nextval('public.cipalan_q')
     , cipath    text[]    NOT NULL
     , selflock  int4
     , whom      text      NOT NULL
     , period    interval
     , strict    bool      NOT NULL DEFAULT FALSE
     , selfgr    bool      NOT NULL DEFAULT FALSE
     , success   bool      NOT NULL DEFAULT TRUE
     , resource  bytea     NOT NULL
     , resar     int4[]
     , renul     text[]
     )
;
#perform 0002
ALTER TABLE public.cipalan ADD IF NOT EXISTS resar int4[];
#perform 0002
ALTER TABLE public.cipalan ADD IF NOT EXISTS renul text[];
#perform 0002
COMMENT ON TABLE public.cipalan          IS '  ';
COMMENT ON COLUMN public.cipalan.cipalan    IS ' ';
COMMENT ON COLUMN public.cipalan.cipath     IS 'PATH  +  ';
COMMENT ON COLUMN public.cipalan.selflock   IS '  (NULL , 0 -   , ...)';
COMMENT ON COLUMN public.cipalan.whom       IS 'uname,   ';
COMMENT ON COLUMN public.cipalan.period     IS ' ';
COMMENT ON COLUMN public.cipalan.strict     IS '     ';
COMMENT ON COLUMN public.cipalan.selfgr     IS '  ';
COMMENT ON COLUMN public.cipalan.success    IS '  ';
COMMENT ON COLUMN public.cipalan.resource   IS '   ';
COMMENT ON COLUMN public.cipalan.resar      IS '    ';
COMMENT ON COLUMN public.cipalan.renul      IS '   ,   resar';
#perform 0002
SELECT setval('public.cipalan_q', MAX(cipalan.cipalan)) FROM public.cipalan;
#perform 0002
CREATE OR REPLACE RULE cipadl AS
    ON DELETE TO public.cipalan
    DO ALSO NOTIFY "cipaxn"
;
# perform 0002
CREATE OR REPLACE RULE cipail AS
    ON INSERT TO public.cipalan
    DO ALSO NOTIFY "cipaxn"
;
#perform 0002
CREATE OR REPLACE RULE cipaul AS
    ON UPDATE TO public.cipalan
    DO ALSO NOTIFY "cipaxn"
;
#perform 0002  ##########################################################################  cipaon  ####
CREATE SEQUENCE IF NOT EXISTS public.cipaxn_q MINVALUE 0;
#perform 0002
CREATE TABLE IF NOT EXISTS public.cipaon
     ( cipaon    int8      PRIMARY KEY DEFAULT nextval('public.cipaxn_q')
     , cipalan   int4      REFERENCES cipalan 
     , ciparg    text[]
     , plan      timestamp NOT NULL
     , deed      timestamp
     , pid       int4
     , reed      timestamp NOT NULL DEFAULT now()
     , try       int4      NOT NULL DEFAULT 0
     )
;
#perform 0002
COMMENT ON TABLE public.cipaon           IS ' ';
COMMENT ON COLUMN public.cipaon.cipaon      IS '  ';
COMMENT ON COLUMN public.cipaon.cipalan     IS '  public.cipalan';
COMMENT ON COLUMN public.cipaon.ciparg      IS ' ';
COMMENT ON COLUMN public.cipaon.pid         IS 'PID ';
COMMENT ON COLUMN public.cipaon.plan        IS '  ';
COMMENT ON COLUMN public.cipaon.deed        IS '  ';
COMMENT ON COLUMN public.cipaon.reed        IS '  ';
COMMENT ON COLUMN public.cipaon.try         IS '  ';
#perform 0002
ALTER TABLE IF EXISTS ONLY public.cipaon ALTER deed DROP NOT NULL;
#perform 0002  ##########################################################################  cipain  ####
CREATE TABLE IF NOT EXISTS public.cipain
     ( cipain    int8      PRIMARY KEY DEFAULT nextval('public.cipaxn_q')
     , cipaher   int8
     , cipalan   int4      REFERENCES cipalan
     , waitout   int8[]
     , ciparg    text[]
     , plan      timestamp NOT NULL DEFAULT now()
     , prio      int2      NOT NULL DEFAULT 1000
     , deed      timestamp
     , pid       int4
     , try       int4      NOT NULL DEFAULT 0
     , ghost     bool      NOT NULL DEFAULT FALSE
     )
;
#perform 0002
ALTER TABLE IF EXISTS public.cipain ADD IF NOT EXISTS ghost bool NOT NULL DEFAULT FALSE;
#perform 0002
ALTER TABLE IF EXISTS public.cipain DROP CONSTRAINT IF EXISTS cipain_cipaher_fkey;
#perform 0002
COMMENT ON TABLE public.cipain           IS '  ';
COMMENT ON COLUMN public.cipain.cipain      IS '  ';
COMMENT ON COLUMN public.cipain.cipaher     IS '  ';
COMMENT ON COLUMN public.cipain.cipalan     IS '  public.cipalan';
COMMENT ON COLUMN public.cipain.waitout     IS '    cipaon.cipaon';
COMMENT ON COLUMN public.cipain.ciparg      IS ' ';
COMMENT ON COLUMN public.cipain.plan        IS '  ';
COMMENT ON COLUMN public.cipain.prio        IS '';
COMMENT ON COLUMN public.cipain.deed        IS '  ';
COMMENT ON COLUMN public.cipain.pid         IS 'PID ';
COMMENT ON COLUMN public.cipain.try         IS '  ';
COMMENT ON COLUMN public.cipain.ghost       IS ' ,  ';
#perform 0002
CREATE INDEX IF NOT EXISTS cipain_t ON public.cipain(plan);
#perform 0002
CREATE INDEX IF NOT EXISTS cipain_h ON public.cipain(cipaher);
#perform 0002
CREATE INDEX IF NOT EXISTS cipain_g ON public.cipain(ghost);
#perform 0002
SELECT setval('public.cipaxn_q', MAX(m.m))
 FROM (SELECT MAX(cipain.cipain) AS m FROM public.cipain
      UNION
       SELECT MAX(cipaon.cipaon) AS m FROM public.cipaon
      )m
;
#select  1001
SELECT '#trap
##return
##perform 0002
DROP RULE IF EXISTS cipadn ON public.cipain;
##perform 0002
DROP RULE IF EXISTS cipain ON public.cipain;
##perform 0002
DROP RULE IF EXISTS cipaun ON public.cipain;
##perform 0002
DROP RULE IF EXISTS cipaon ON public.cipaxn;
##perform 0002
DROP RULE IF EXISTS cipaan ON public.cipaxn;
##perform 0002
DROP VIEW IF EXISTS public.cipaxn;
##untrap
'FROM v
 WHERE v < 0.12
;
#eval    01
#begin   0002
#perform 0002  ##########################################################################  cipaxn  ####
CREATE OR REPLACE VIEW public.cipaxn AS
 WITH z AS(SELECT cipain, row_number() OVER (PARTITION BY cipain) AS cipalevel, arg
            FROM(SELECT cipain
                      , COALESCE((a.cipath || cipain.ciparg)[anum], a.aval) AS arg
                  FROM  (SELECT cipalan, cipath, unnest(resar) AS anum, unnest(renul) AS aval
                          FROM public.cipalan
                        )a
                   JOIN public.cipain USING(cipalan)
                )b
            WHERE arg IS NOT NULL
          UNION
           SELECT cipain, 0, NULL::text FROM public.cipain
          ORDER BY cipain, cipalevel, arg
         )
  SELECT cipain.cipain
       , cipain.cipaher
       , cipain.cipalan
       , cipain.waitout
       , cipain.ciparg
       , cipain.plan
       , cipain.prio
       , cipain.deed
       , cipain.pid
       , cipain.try
       , cipain.ghost
       , (   cipain.pid IS NULL
         AND NOT EXISTS(SELECT 1
                         FROM unnest(cipain.waitout)h LEFT JOIN public.cipaon ON(h = cipaon.cipaon)
                         WHERE cipaon.cipaon IS NULL
                       )
         AND NOT EXISTS(SELECT 1
                         FROM public.cipain c JOIN public.cipalan b USING(cipalan)
                         WHERE public.compare( cipalan.selflock
                                             , cipalan.cipath || cipain.ciparg
                                             , b.cipath || c.ciparg
                                             )
                           AND c.pid IS NOT NULL
                       )
         AND public.bytearrmax(public.bytearradd(cipalan.resource, COALESCE(s.resum, '\x'))) < 255
         ) AS ready
   FROM       public.cipain
         JOIN public.cipalan USING(cipalan)
    LEFT JOIN (SELECT cipain, public.bytearrsum(resum) AS resum
                FROM z
                 LEFT JOIN(SELECT cipalevel
                                , arg
                                , public.bytearrsum(public.bytearrmask( cipalan.resource
                                                                      , cipamask.cipamask
                                                   )                  ) AS resum
                            FROM public.cipamask
                             JOIN z USING(cipalevel)
                             JOIN public.cipain  USING(cipain)
                             JOIN public.cipalan USING(cipalan)
                            WHERE cipain.pid IS NOT NULL
                           GROUP BY arg, cipalevel
                          )c USING(cipalevel, arg)
               GROUP BY cipain
              )s USING(cipain)
   WHERE NOT ghost
;
#perform 0002
COMMENT ON VIEW public.cipaxn            IS '  ';
COMMENT ON COLUMN public.cipaxn.cipain      IS '  ';
COMMENT ON COLUMN public.cipaxn.cipaher     IS '    period';
COMMENT ON COLUMN public.cipaxn.cipalan     IS '  public.cipalan';
COMMENT ON COLUMN public.cipaxn.waitout     IS '    cipaon.cipaon';
COMMENT ON COLUMN public.cipaxn.ciparg      IS ' ';
COMMENT ON COLUMN public.cipaxn.plan        IS '  ';
COMMENT ON COLUMN public.cipaxn.prio        IS '';
COMMENT ON COLUMN public.cipaxn.deed        IS '  ';
COMMENT ON COLUMN public.cipaxn.pid         IS 'PID ';
COMMENT ON COLUMN public.cipaxn.try         IS '  ';
COMMENT ON COLUMN public.cipaxn.ghost       IS ' ,  ';
COMMENT ON COLUMN public.cipaxn.ready       IS '   ';
#perform 0002
CREATE OR REPLACE FUNCTION public.cipaun(int8)
 RETURNS TABLE( cipain  int8
              , cipaher int8
              , cipalan int4
              , waitout int8[]
              , ciparg  text[]
              , plan    timestamp
              , prio    int2
              , deed    timestamp
              , pid     int4
              , try     int4
              , ghost   bool
              )
 AS ' NOTIFY "cipaxn"
    ; WITH y AS(SELECT d.cipain
                 FROM  public.cipain d
                  JOIN public.cipain i USING(cipalan)
                  JOIN public.cipalan  USING(cipalan)
                 WHERE (d.waitout, d.ciparg) IS NOT DISTINCT FROM (i.waitout, i.ciparg)
                   AND i.cipain = $1
                   AND cipalan.selfgr
                   AND i.plan < now()
                   AND d.plan < i.deed
                   AND NOT d.ghost
                   AND NOT i.ghost
               UNION
                SELECT $1
               EXCEPT
                SELECT cipaon.cipaon FROM cipaon
               )
         , k AS(INSERT INTO public.cipain(cipaher, cipalan, ciparg, plan, waitout, prio)
                 SELECT i.cipain
                      , i.cipalan
                      , i.ciparg
                      , CASE WHEN cipalan.strict
                             THEN i.plan
                             ELSE COALESCE(i.deed, now())
                        END + cipalan.period
                      , (SELECT array_agg(cipain.cipain)
                           FROM public.cipain, unnest(i.waitout)u
                          WHERE cipain.cipaher = u
                        )
                      , i.prio
                  FROM public.cipalan JOIN public.cipain i USING(cipalan)
                  WHERE i.cipain = $1
                    AND cipalan.period IS NOT NULL
               )
         , c AS(DELETE FROM public.cipain
                 WHERE cipain.cipain IN(SELECT y.cipain FROM y)
                RETURNING cipain, cipaher, cipalan, waitout, ciparg, plan, prio, deed, pid, try, ghost
               )
         , e AS(INSERT INTO public.cipaon(cipaon, cipalan, ciparg, pid, plan, deed, try)
                 SELECT cipain, cipalan, ciparg, pid, plan, deed, try
                  FROM c
               )
      SELECT cipain, cipaher, cipalan, waitout, ciparg, plan, prio, deed, pid, try, ghost
       FROM c
    '
 LANGUAGE SQL
 VOLATILE
 STRICT
 PARALLEL UNSAFE
;
#perform 0002
COMMENT ON FUNCTION public.cipaun(int8) IS '   RULE cipadn ON DELETE TO cipaxn';
#perform 0002
CREATE OR REPLACE RULE cipadn AS
    ON DELETE TO public.cipaxn
    DO INSTEAD
    ( NOTIFY "cipaxn"
    ; SELECT * FROM public.cipaun(OLD.cipain)
    )
;
#perform 0002
CREATE OR REPLACE RULE cipain AS
    ON INSERT TO public.cipaxn
    DO INSTEAD
    ( NOTIFY "cipaxn"
    ; INSERT INTO public.cipain(cipaher, cipalan, waitout, ciparg, plan, prio, ghost)
       SELECT NEW.cipaher
            , NEW.cipalan
            , NEW.waitout
            , NEW.ciparg
            , COALESCE(NEW.plan, now())
            , COALESCE(NEW.prio, 1000)
            , COALESCE(NEW.ghost, FALSE)
        FROM public.cipalan
        WHERE cipalan.cipalan = NEW.cipalan
      RETURNING cipain, cipaher, cipalan, waitout, ciparg, plan, prio, deed, pid, try, ghost, FALSE
    )
;
#perform 0002
CREATE OR REPLACE RULE cipaun AS
    ON UPDATE TO public.cipaxn
    DO INSTEAD
    ( NOTIFY "cipaxn"
    ; UPDATE public.cipain
         SET waitout = NEW.waitout
           , ciparg  = NEW.ciparg
           , plan    = NEW.plan
           , prio    = NEW.prio
           , deed    = NEW.deed
           , pid     = NEW.pid
           , try     = NEW.try
           , ghost   = NEW.ghost
       WHERE cipain = NEW.cipain
      RETURNING cipain, cipaher, cipalan, waitout, ciparg, plan, prio, deed, pid, try, ghost, FALSE
    )
;
#perform 0002  #############################################################################  API  ####
CREATE TABLE IF NOT EXISTS public.cipaghost
     ( m      text
     , v      text
     , cipain int8 REFERENCES cipain
     , PRIMARY KEY(m, v)
     )
;
#perform 0002
COMMENT ON TABLE public.cipaghost        IS '  ';
COMMENT ON COLUMN public.cipaghost.m        IS '  - ';
COMMENT ON COLUMN public.cipaghost.v        IS '    ';
COMMENT ON COLUMN public.cipaghost.cipain   IS '   ';
#perform 0002
CREATE OR REPLACE VIEW public.cipaup AS
 SELECT m
      , v
      , cipain
      , cipalan
      , waitout
      , ciparg
      , now()::timestamp AS plan
      , prio
  FROM public.cipaghost JOIN public.cipain USING(cipain)
  WHERE ghost
;
#perform 0002
COMMENT ON VIEW public.cipaup            IS '  ';
COMMENT ON COLUMN public.cipaup.m           IS '  - ';
COMMENT ON COLUMN public.cipaup.v           IS '    ';
COMMENT ON COLUMN public.cipaup.cipain      IS '  ';
COMMENT ON COLUMN public.cipaup.cipalan     IS '  public.cipalan';
COMMENT ON COLUMN public.cipaup.waitout     IS '    cipaon.cipaon';
COMMENT ON COLUMN public.cipaup.ciparg      IS ' ';
COMMENT ON COLUMN public.cipaup.plan        IS '  ';
COMMENT ON COLUMN public.cipaup.prio        IS '';
#perform 0002
CREATE OR REPLACE FUNCTION public.cipatree(int8, int8[], text[], timestamp, int2)
 RETURNS SETOF public.cipain
 AS $tree$
    DECLARE
        i RECORD;
    BEGIN
        SET LOCAL client_min_messages = 'WARNING';
        DROP TABLE IF EXISTS "cipatree copy cupport a";
        DROP TABLE IF EXISTS "cipatree copy cupport b";
        DROP TABLE IF EXISTS "cipatree copy cupport d";
        DROP TABLE IF EXISTS "cipatree copy cupport z";
        SET LOCAL client_min_messages TO DEFAULT;
        CREATE TEMP TABLE "cipatree copy cupport a"
         ON COMMIT DROP
         AS WITH RECURSIVE
                 r AS (SELECT 0 AS ord, cipain.cipain, unnest(cipain.waitout) AS wait
                        FROM public.cipain
                        WHERE cipain.cipain = $1
                      UNION
                       SELECT r.ord + 1 AS ord, cipain.cipain, unnest(cipain.waitout) AS wait
                        FROM public.cipain JOIN r ON(cipain.cipain = r.wait)
                      )
            SELECT *
             FROM r
    ;
        CREATE TEMP TABLE "cipatree copy cupport b"
         ON COMMIT DROP
         AS SELECT MAX(d.ord) AS ord, d.cipain, MAX(cipain.plan) AS plan
             FROM (SELECT a.ord, a.cipain
                    FROM "cipatree copy cupport a" a
                  UNION
                   SELECT a.ord + 1, cipain.cipain
                    FROM "cipatree copy cupport a" a JOIN public.cipain ON(cipain.cipain = a.wait)
                    WHERE COALESCE(cardinality(cipain.waitout), 0) = 0
                  UNION
                   SELECT COALESCE(c.ord, 0) + 1, cipain.cipain
                    FROM (SELECT MAX(g.ord) + 1 AS ord FROM "cipatree copy cupport a" g)c
                       , public.cipain
                    WHERE COALESCE(cardinality(cipain.waitout), 0) = 0
                      AND cipain.cipain = $1
                  )d
              JOIN public.cipain USING(cipain)
            GROUP BY d.cipain
    ;
        CREATE TEMP TABLE "cipatree copy cupport d"
         ON COMMIT DROP
         AS SELECT DISTINCT b.cipain, a.wait
             FROM "cipatree copy cupport b" b LEFT JOIN "cipatree copy cupport a" a USING(cipain)
    ;
        CREATE TEMP TABLE "cipatree copy cupport z"(cipain int8, cipaher int8) ON COMMIT DROP;

        FOR i
         IN SELECT row_number() OVER(ORDER BY b.ord DESC) AS row
                 , b.cipain
                 , cipain.plan - e.e + COALESCE($4, now()) AS plan
             FROM "cipatree copy cupport b" b JOIN public.cipain USING(cipain)
                , (SELECT MIN(c.plan) AS e FROM "cipatree copy cupport b" c)e
            ORDER BY row
        LOOP
            RETURN QUERY
             WITH y AS(SELECT i.cipain, NULLIF(array_remove(array_agg(d.wait), NULL), '{}') AS waitout
                        FROM "cipatree copy cupport d" d
                         LEFT JOIN "cipatree copy cupport z" z ON(d.wait = z.cipaher)
                        WHERE d.cipain = i.cipain
                       GROUP BY i.cipain
                      )
                , x AS(INSERT INTO public.cipain(cipaher, cipalan, waitout, ciparg, plan, prio)
                        SELECT i.cipain
                             , ci.cipalan
                             , $2 || y.waitout
                             , ci.ciparg || $3
                             , i.plan
                             , COALESCE($5, ci.prio)
                         FROM public.cipain ci JOIN y USING(cipain)
                         WHERE y.cipain = i.cipain
                        RETURNING cipain.cipain
                                , cipain.cipaher
                                , cipain.cipalan
                                , cipain.waitout
                                , cipain.ciparg
                                , cipain.plan
                                , cipain.prio
                                , cipain.deed
                                , cipain.pid
                                , cipain.try
                                , cipain.ghost
                      )
                , w AS(INSERT INTO "cipatree copy cupport z"
                        SELECT x.cipain, x.cipaher
                         FROM x
                      )
             SELECT x.cipain
                  , x.cipaher
                  , x.cipalan
                  , x.waitout
                  , x.ciparg
                  , x.plan
                  , x.prio
                  , x.deed
                  , x.pid
                  , x.try
                  , x.ghost
              FROM x
    ;
        END LOOP;
        NOTIFY "cipaxn";
        RETURN;
    END;
$tree$
LANGUAGE plpgsql
;
#perform 0002
COMMENT ON FUNCTION public.cipatree(int8, int8[], text[], timestamp, int2)
 IS ' ,   '
;
#perform 0002
CREATE OR REPLACE RULE cipagup AS
    ON UPDATE TO public.cipaup
    DO INSTEAD
    ( NOTIFY "cipaxn"
    ; SELECT NULL::text, NULL::text, cipain, cipalan, waitout, ciparg, plan, prio
       FROM public.cipatree(OLD.cipain, NEW.waitout, NEW.ciparg, NEW.plan, NEW.prio)
    )
;
#perform 0002  #########################################################################  cipapan  ####
CREATE TABLE IF NOT EXISTS public.cipapan
     ( m       text
     , v       text
     , cipalan int
     , PRIMARY KEY(m, v)
     )
;
#perform 0002
COMMENT ON TABLE public.cipapan        IS '   ';
COMMENT ON COLUMN public.cipapan.m        IS '  - ';
COMMENT ON COLUMN public.cipapan.v        IS '    ';
COMMENT ON COLUMN public.cipapan.cipalan  IS '  cipalan.cipalan';
#perform 0002
CREATE OR REPLACE FUNCTION public.topute() RETURNS trigger AS
$topute$
    BEGIN
        UPDATE public.cipaup
           SET ciparg = ciparg || TG_ARGV[2:]
         WHERE (cipaup.m, cipaup.v) = (TG_ARGV[0], TG_ARGV[1])
    ;
         RETURN NULL;
    END;
$topute$
LANGUAGE plpgsql
;
#perform 0002
COMMENT ON FUNCTION public.topute() IS '     ';
#perform 0002
CREATE OR REPLACE FUNCTION public.cipatree(int8)
 RETURNS SETOF public.cipain
 AS $tree$
    WITH a AS(WITH RECURSIVE r AS(SELECT cipain.cipain, unnest(cipain.waitout) AS wait
                                   FROM public.cipain
                                   WHERE cipain.cipain = $1
                                 UNION
                                  SELECT cipain.cipain, unnest(cipain.waitout) AS wait
                                   FROM public.cipain JOIN r ON(cipain.cipain = r.wait)
                                 )
              SELECT *
               FROM r
             )
       , b AS(SELECT a.cipain FROM a
             UNION
              SELECT cipain.cipain
               FROM a JOIN public.cipain ON(cipain.cipain = a.wait)
               WHERE COALESCE(cardinality(cipain.waitout), 0) = 0
             UNION
              SELECT cipain.cipain
               FROM public.cipain
               WHERE COALESCE(cardinality(cipain.waitout), 0) = 0
                 AND cipain.cipain = $1
             )
    SELECT cipain.* FROM b JOIN public.cipain USING(cipain)
$tree$
LANGUAGE sql
;
#perform 0002
COMMENT ON FUNCTION public.cipatree(int8) IS '     ';
#select  1001
SELECT 'GRANT SELECT ON public.cipares_q
                      , public.cipares
                      , public.ciparam
                      , public.cipalan_q
                      , public.cipalan
                      , public.cipaon
                      , public.cipain
                      , public.cipaxn_q
                      , public.cipaxn
                      , public.cipamask
                      , public.cipalevel_q
                      , public.cipaghost
                      , public.cipaup
                      , public.cipapan
                     TO operator, root, ' || b || '
;
'FROM x
;
#perform 0102
#select  1001
SELECT 'GRANT INSERT ON public.cipain
                      , public.cipaxn
                      , public.cipaon
                      , public.cipares
                     TO operator, root, ' || b || '
;
'FROM x
;
#perform 0102
#select  1001
SELECT 'GRANT DELETE ON public.cipain, public.cipaxn TO operator, root, ' || b || ';
'FROM x
;
#perform 0102
#select  1001
SELECT 'GRANT UPDATE ON public.cipaup TO operator, root, ' || b || ';
'FROM x
;
#perform 0102
#select  1001
SELECT 'GRANT USAGE, UPDATE ON public.cipares_q, public.cipalan_q TO operator, root, ' || b || ';
'FROM x
;
#perform 0102
#perform 0002
GRANT INSERT ON public.cipalan TO operator;
#select  1001
SELECT 'GRANT UPDATE ON public.cipain, public.cipaxn_q TO operator, root, ' || b || ';
'FROM x
;
#perform 0102
#select  1001
SELECT 'GRANT EXECUTE ON FUNCTION public.cipaun(int8) TO operator, root, ' || b || ';
'FROM x
;
#perform 0102
#select  1001
SELECT 'GRANT EXECUTE ON FUNCTION public.topute() TO operator, root, ' || b || ';
'FROM x
;
#perform 0102
#perform 0002
GRANT DELETE ON public.cipaxn TO root;
#end     0002
